;***************************************************************************
;* Netzschalter und Ferbedienungsempfnger / Konverter *
;***************************************************************************

;** Signale ...
;Port	Pin	Bit	DIR	Akt	Signal
;A	39	0	O	H	IR-Ausgang
;A	38	1	O	L	Status-LED
;A	37	2	O		Schaltsignal TV / VCR		xxx
;A	36	3	O	H	HiFi Ein
;A	35	4	O	H	Gert ein (NEU)
;A	34	5	O	L	Licht ein
;A	33	6	O	L	VCR Netz ein
;A	32	7	O	L	TV Netz ein

;B	1	0
;B	2	1
;B	3	2
;B	4	3
;B	5	4
;B	6	5			(MOSI)
;B	7	6			(MISO)
;B	8	7			(SCK)

;C	21	0	O	H	Gert ein (ALT)
;C	22	1
;C	23	2	I	L	VCR Schaltsignal		xxx
;C	24	3	I		IR-Empfnger
;C	25	4	O		Audioschalter Input L1		xxx
;C	26	5	O		Audioschalter Input L2		xxx
;C	27	6	O		Audioschalter AV L1		xxx
;C	28	7	O		Audioschalter AV L2		xxx

;D	10	0	I/O		Display Data 0 (4)
;D	11	1	I/O		Display Data 1 (5)
;D	12	2	I/O		Display Data 2 (6)
;D	13	3	I/O		Display Data 3 (7)
;D	14	4	O	H	Display EN
;D	15	5	O	H	Displaybeleuchtung (evl.(OC1A)-PWM fr Dimmen)
;D	16	6	O		Display R/S
;D	17	7	O		Display R/W

;Schaltkreis spezifische Einstellungen ...
.device AT90S8515	;8k-FLASH 512Byte RAM/EEPROM
.equ	RAMEND	=	$25f

.include	"DataTab_offs.inc"



;IO-Adressen
.equ	PORTA	=	$1b
.equ	DDRA	=	$1a
.equ	PINA	=	$19
.equ	PORTB	=	$18
.equ	DDRB	=	$17
.equ	PINB	=	$16
.equ	PORTC	=	$15
.equ	DDRC	=	$14
.equ	PINC	=	$13
.equ	PORTD	=	$12
.equ	DDRD	=	$11
.equ	PIND	=	$10
.equ	SPL	=	$3d
.equ	SPH	=	$3e
.equ	SReg	=	$3f
.equ	TCCR0	=	$33
.equ	TCNT0	=	$32
.equ	TCCR1A	=	$2f
.equ	TCCR1B	=	$2e
.equ	TCNT1H	=	$2d
.equ	TCNT1L	=	$2c
.equ	OCR1AH	=	$2b
.equ	OCR1AL	=	$2a
.equ	GIMSK	=	$3b
.equ	GIFR	=	$3a
.equ	TIMSK	=	$39
.equ	TIFR	=	$38
.equ	EEARH	=	$1f
.equ	EEARL	=	$1e
.equ	EEDR	=	$1d
.equ	EECR	=	$1c	
.equ	MCUCR	=	$35

;IO-Bitdefinitionen
;Port A
.equ	IROUT_Bit	=	0
.equ	Status_Bit	=	1
;.equ	TV_VCR_Bit	=	2
.equ	HiFiNetz_Bit	=	3
.equ	GerON2_Bit	=	4
.equ	LichtNetz_Bit	=	5
.equ	VCRNetz_Bit	=	6
.equ	TVNetz_Bit	=	7

;Port B

;Port C
;.equ	GerON_Bit	=	0
;.equ	VCRSwitch_Bit	=	2
.equ	IRIN_Bit	=	3

;Port D
.equ	Display_EN_Bit	=	4
.equ	Display_Licht_Bit=	5
.equ	Display_RS_Bit	=	6
.equ	Display_RW_Bit	=	7

;IO-Portmasken und Startwerte
.equ	PortA_DIR	=	0b11111111
.equ	PortA_DAT	=	0b11110010
.equ	PortB_DIR	=	0b00000000
.equ	PortB_DAT	=	0b00000000
.equ	PortC_DIR	=	0b11110001
.equ	PortC_DAT	=	0b00001100
.equ	PortD_DIR_W	=	0b11111111
.equ	PortD_DIR_R	=	0b11110000
.equ	PortD_DAT	=	0b00000000

;BeoEmpf. Werte		** Timer luft mit 1MHz =^= 0.256 ms
;			** pro berlauf - MaxZeit = 65.28ms
.equ	TK		=	4	;rund 4 Takte pro ms
.equ	TimerMax	=	17*TK
.equ	BeoMaxDiff	=	3	;0.75*TK
.equ	BeoBit0Time	=	12	;3*TK
.equ	BeoBit1Time	=	24	;6*TK
.equ	BeoBit2Time	=	36	;9*TK

;Gerte
.equ	Ger_TV		=	1
.equ	Ger_VCR		=	2
.equ	Ger_SAT		=	3
.equ	Ger_Licht	=	4

;sonstige Werte
.equ	MaxSetMode	=	16	;Anzahl der DSD_Meneintrge
.equ	AnzSaveData	=	11	;Anzahl der zu speichernden Daten
.equ	Time2Prog	=	613	;Zeit fr 2stellige Programme (*4,08ms)
.equ	Power_PulseV	=	4	;1:3

.equ	T1_SecCtrN	=	0
.equ	T1_SysCtrN	=	1
;Display Sonderzeichen
.equ	CHR_ae	=	0xE1
.equ	CHR_oe	=	0xEF
.equ	CHR_ue	=	0xF5
.equ	CHR_sz	=	0xE2
.equ	CHR_phi	=	0xEC

;Einstellwerte fr EEPROM
;.equ	S_DS_Betiebsart	=	1	;FLIM
;.equ	S_PC1853_SA00	=	0b11100001
;.equ	S_PC1853_SA08	=	0b10000000+6
;.equ	S_PC1853_BASS	=	32+10
;.equ	S_PC1853_TREB	=	32+6
;.equ	S_AUXMODE_NDEC	=	1
;.equ	S_AUXMODE_DEC	=	1
;.equ	S_GerPowerON	=	(1<<VCRNetz_Bit)
;.equ	S_AutoPowerOff	=	1	;JA
;.equ	S_PowerON_Vol	=	28
;.equ	S_CenterVol	=	0

;Registerdefinitionen
.def	WorkL		=	r0
.def	TempL1		=	r1
.def	TempL2		=	r2
.def	PWR_PulseCnt	=	r3
.def	TVProg		=	r4
.def	TempL0		=	r5
.def	TVProgMode	=	r6
.def	SEC_CtrL	=	r7
.def	SEC_CtrH	=	r8
.def	ISNULL		=	r9
.def	HiFi_Togg	=	r10
.def	PWRMODE		=	r11
.def	STATUS_Cnt	=	r12
.def	Timer1_TL	=	r13
.def	SRegSave 	=	r14
.def	SysTime_Cnt 	=	r15

.def	WorkU		=	r16
.def	WorkU1		=	r17
.def	T1_STATE	=	r18
.def	TempU1		=	r19
.def	TempU2		=	r20
.def	TV_Send_Code	=	r21
.def	TempU0		=	r22
.def	SysTime_25s	=	r23
.def	Timer		=	r24
.def	DispDat		=	r25
.def	X_L		=	r26
.def	X_H		=	r27
.def	Y_L		=	r28
.def	Y_H		=	r29
.def	Z_L		=	r30
.def	DATA_L		=	r30
.def	Z_H		=	r31
.def	DATA_H		=	r31

;Macrodefionen
.macro Text	;schreibt die Adressen des Texts in das
		;X_Reg. und ruft das Unterprogramm auf.
	ldi	X_H,high(@0*2)
	ldi	X_L,low(@0*2)
	rcall	showtext
.endmacro
.macro	PushZ	;Z_H und Z_L auf Stack
	push	Z_H
	push	Z_L
.endmacro
.macro	PopZ
	pop	Z_L
	pop	Z_H
.endmacro
.macro	PushX	;X_H und X_L auf Stack
	push	X_H
	push	X_L
.endmacro
.macro	PopX
	pop	X_L
	pop	X_H
.endmacro
.macro	adi
	subi	@0,256-@1
.endmacro
.macro	mov_w	;16-Bit Reg. kopieren
	mov	@0_L,@1_L
	mov	@0_H,@1_H
.endmacro
.macro	ldiw_m	;16-Bit Adresse aus FLASH laden
	ldi	@0_L,low(@1*2)
	ldi	@0_H,high(@1*2)
.endmacro
.macro	ldiw	;16-Bit Adresse aus EEProm / Ram laden
	ldi	@0_L,low(@1)
	ldi	@0_H,high(@1)
.endmacro
.macro	stsw	;16-Bit Wert in Ram-speichern
	sts	@0,@1_L
	sts	@0+1,@1_H
.endmacro 
.macro	ldsw	;16-Bit Wert aus Ram-speichern laden
	lds	@0_L,@1
	lds	@0_H,@1+1
.endmacro 
.macro	EE_Read
	sbi	EECR,0
.endmacro
.macro	Dimmer_n	;Wert fr Dimmer Einstellen
	ldi	WorkU,@0
	out	OCR1AL,WorkU
.endmacro
.macro	Dimmer_R	;Register fr Dimmer einstellen
	out	OCR1AL,@0
.endmacro
	
.cseg
.org	0

RESET:
I_Reset:	rjmp	Start
I_Int0:		reti
I_Int1:		reti
I_Timer1_Capt:	reti
I_Timer1_ComA:	reti
I_Timer1_ComB:	reti
I_Timer1_OV:	rjmp	Timer1_OV
I_Timer0_OV:	rjmp	Timer0_Hand
I_SPI:		reti
I_UART_Rx:	reti
I_UART_UDRE:	reti
I_UART_Tx:	reti
I_ANA_CMP:	reti

.include	"Send_TV.inc"
.include	"Send_VCR.inc"
.include	"Send_HTS.inc"
.include	"BEO_Rout.inc"
.include	"BEO_Code.inc"
.include	"Display.inc"


;**** Unterprogramme ****
Timer1_OV:	;Aufruf alle 4.08ms
		;245 Durchlufe = 1sec
		; 49 Durchlufe = 200msec
		in	SRegSave,SReg
		mov	TempL0,SEC_CtrL
		or	TempL0,SEC_CtrH
		breq	T1_ov_m0
		sec	;C=1
		sbc	SEC_CtrL,ISNULL
		sbc	SEC_CtrH,ISNULL
		mov	TempL0,SEC_CtrL
		or	TempL0,SEC_CtrH
		brne	T1_ov_m0
		sbr	T1_STATE,1<<T1_SecCtrN
T1_ov_m0:	dec	Timer1_TL
		brne	T1_ov_e
		ldi	TempU0,24
		mov	Timer1_TL,TempU0
	;ab hier alle 97.92ms
	;#### Power
		tst	PWR_PulseCnt
		breq	T1_ov_pe	;wenn 0 dann aus
		dec	PWR_PulseCnt
		brne	T1_ov_p0
	;==0
		ldi	TempU0,Power_PulseV
		mov	PWR_PulseCnt,TempU0
		sbi	PORTA,GerON2_Bit	;PWR-ON
		rjmp	T1_ov_pe
T1_ov_p0:;<>0
		cbi	PORTA,GerON2_Bit	;PWR-OFF
T1_ov_pe:
	;#### Status LED
		sbic	PORTA,Status_Bit
		rjmp	T1_ov_le
		dec	Status_Cnt
		brne	T1_ov_le
T1_ov_le:	sbi	PORTA,Status_Bit
	;#### SystemZeit
		dec	SysTime_Cnt
		brne	T1_ov_se
		;alle 25sec
		sbr	T1_STATE,1<<T1_SysCtrN
		dec	SysTime_25s	
T1_ov_se:
T1_ov_e:	out	SReg,SRegSave
		reti
				
	
Pause_n50us:	;bergabe in WorkU1 (mal 50us)
		push	TempU1
		push	WorkU1
P50Loop0:	ldi	TempU1,131
P50Loop1:	dec	TempU1		
		brne	P50Loop1	
		dec	WorkU1
		brne	P50Loop0	;warten bis Zeit=0
		pop	WorkU1
		pop	TempU1
		ret

		
Timer0_Hand:	;wird per Timer0_OV_Int. ausgelst
		in	SRegSave,SReg
		dec	Timer
		brne	Timer0_End
		clr	TempL0		;wenn 0 dann
		out	TCCR0,TempL0	;Timer aus		
Timer0_End:	out	SReg,SRegSave
		reti

SetPower_ON:	;Full Power
		cli
		clr	PWR_PulseCnt
		sbi	PORTA,GerOn2_Bit
		sei
		ret

SetPower_OFF:	;Gert AUS
		cli
		cbi	PORTA,GerOn2_Bit
SPO_Loop:	rjmp	SPO_Loop


SetPower_STB:	;Standby-Power
		in	TempU1,PortA
		andi	TempU1,0b10100000 ;nur Netzbits auer HiFi
		cpi	TempU1,0b10100000 ;alle aus ??
		brne	SP_STB_e
		;TV & Licht sind aus
		sbis	PORTA,VCRNetz_Bit	;VCR aus ?
		sbis	PORTA,HiFiNetz_Bit	;HiFi an ?
		rjmp	SP_STB_0
		ret
SP_STB_0:	Dimmer_n	0
		ldi	TempU1,Power_PulseV
		mov	PWR_PulseCnt,TempU1
SP_STB_e:	ret
		
	
WaitInput:
WaitInput_Loop:	
		;clr	STATUS_CYC_L0
;WaitInput_B_Loop:
		sbis	PInC,IRIN_Bit
		rjmp	ReadBeo	;==>Rckkehr zur Hauptschleifen
		sbrs	T1_STATE,T1_SecCtrN
		rjmp	WaitInp_01	;Zeit abgelaufen ????
		cbr	T1_STATE,1<<T1_SecCtrN
		rcall	STimer0_END	
		rcall	ShowTVProg
WaitInp_01:	sbrs	T1_STATE,T1_SysCtrN	;wird alle 25sec gesetzt
		rjmp	WaitInput_Loop
		cbr	T1_STATE,1<<T1_SysCtrN
		tst	PWR_PulseCnt
		brne	WaitInp_02
		rcall	SetPower_STB
WaitInp_02:
		in	TempU1,PortA
		andi	TempU1,0b11101000	;nur Netzbits
		ldi	TempU2,0b00001000
		eor	TempU1,TempU2
		cpi	TempU1,0b11101000	;alle aus ??
		brne	WaitInput_Loop
		rcall	ShowSwitchOff
		tst	SysTime_25s
		brne	WaitInput_Loop
		rcall	SetPower_OFF
		rjmp	WaitInput_Loop

ShowSwitchOff:
		ldi	DispDat,1		;CLS
		rcall	Disp_Send_Code
		ldi	DispDat,128
		rcall	Disp_Send_Code
		Text	PWR_OFF1_Txt
		ldi	DispDat,192
		rcall	Disp_Send_Code
		Text	PWR_OFF2_Txt
		ldi	DispDat,192
		rcall	Disp_Send_Code
		mov	WorkU1,SysTime_25s
		mov	TempU1,WorkU1
		lsr	WorkU1			;/2
		ldi	TempU2,11
		rcall	div8u			;/11
		sub	WorkU1,TempU1
		rjmp	DezOut
		
;*  TempU1 = TempU1 / TempU2 , Rest TempL1

div8u:	sub	TempL1,TempL1	;clear remainder and carry
	ldi	WorkU,9		;init loop counter
d8u_1:	rol	TempU1		;shift left dividend
	dec	WorkU		;decrement counter
	brne	d8u_2		;if done
	ret			;    return
d8u_2:	rol	TempL1		;shift dividend into remainder
	sub	TempL1,TempU2	;remainder = remainder - divisor
	brcc	d8u_3		;if result negative
	add	TempL1,TempU2	;    restore remainder
	clc			;    clear carry to be shifted into result
	rjmp	d8u_1		;else
d8u_3:	sec			;    set carry to be shifted into result
	rjmp	d8u_1

		

ShowGer:	rcall	DisplayLight
		ldi	DispDat,1	;CLS
		rcall	Disp_Send_Code
		ldd	TempL1,Z+Geraet	;gert
		mov	TempU1,TempL1
		lsl	TempL1
		lsl	TempL1
		lsl	TempL1		;(*8)
		ldiw_m	X,GerText
		clr	TempL2
		add	X_L,TempL1
		adc	X_H,TempL2
		rcall	ShowText	;Gertename zeigen
	;Netzstatus anzeigen ...
		ldi	DispDat,135
		rcall	Disp_Send_Code	

		cpi	TempU1,1	;TV
		brne	ShowGer_n0
		sbis	PortA,TVNetz_Bit
		rjmp	ShowGer_n0a
		Text	Geraet_Off_Txt
		rjmp	ShowGer_End
ShowGer_n0:	cpi	TempU1,2	;VCR
		brne	ShowGer_n1
		sbis	PortA,VCRNetz_Bit
		rjmp	ShowGer_End
		Text	Geraet_Off_Txt
		rjmp	ShowGer_End

ShowGer_n1:	cpi	TempU1,3	;HiFi
		brne	ShowGer_End
		sbic	PortA,HiFiNetz_Bit
		rjmp	ShowGer_End
		Text	Geraet_Off_Txt
		rjmp	ShowGer_End

ShowGer_n0a:	;Spezial ...
		;set
		;bld	TVProgMODE,7	;Anzeige EIN
		rcall	ShowTVProg
	;.....................................
ShowGer_End:	lds	TempL2,ShowCode_M
		sbrs	TempL2,0	;Codeanzeigemodus ??
		ret
;		ldi	DispDat,192
;		rcall	Disp_Send_Code
;		Text	CodeAnT1
;		ldi	DispDat,193
;		rcall	Disp_Send_Code
;		ldd	DispDat,Z+Geraet
;		adi	DispDat,0x30
;		rcall	Disp_Send_Data
	;rcall	ShowCodes
		ret

;ShowCodes:		
;		ldi	DispDat,196
;		rcall	Disp_Send_Code
;		ldd	WorkU1,Z+Taste
;		rcall	DezOut
		
;		ldi	DispDat,201
;		rcall	Disp_Send_Code
;		ldd	WorkU1,Z+TasteL1
;		rcall	DezOut

;		ldi	DispDat,206
;		rcall	Disp_Send_Code
;		ldd	WorkU1,Z+TasteL2
;		rcall	DezOut

;		ret

ShowTVProg:	;PROGRAMM zeigen
		sbrs	TVProgMODE,7	;Anzeige EIN ??
ShowTVP_ex:	ret
		ldd	TempU1,Z+Geraet
		cpi	TempU1,1	;TV ??
		brne	ShowTVP_ex
		ldd	TempU1,Z+Ank_Netz_Aus
		tst	TempU1
		;brne	ShowTVP_ex	;Ank. Netz aus - keine Anzeige
		ldi	DispDat,141
		rcall	Disp_Send_Code
		sbrc	TVProgMODE,0	;TextMODE ??
		rjmp	ShowTP_em0
		mov	DispDat,TVProg
		swap	DispDat		;Zehner nach unten
		andi	DispDat,0xF
		cpi	DispDat,0xF	;keine Zahl ??
		brne	ShowTP_m00
		ldi	DispDat,-3
ShowTP_m00:	adi	DispDat,48
		rcall	Disp_Send_Data	;Zehner ausgeben
		mov	DispDat,TVProg
		andi	DispDat,0xF	;Einer
		cpi	DispDat,0xF	;keine Zahl ??
		brne	ShowTP_m01
		ldi	DispDat,-3
ShowTP_m01:	adi	DispDat,48
		rcall	Disp_Send_Data	;Einer ausgeben
		ret
		
ShowTP_em0:	ldi	DispDat,42	;2x "*" ausgeben
		rcall	Disp_Send_Data
		ldi	DispDat,42
		rcall	Disp_Send_Data
		ret
		
ShowText:	;bergabe der Anfangsadresse in X
		;Umlaute werden umgewandelt
		PushZ
		mov_w	Z,X
ShowT_Loop:	lpm			;(Z)->r0
		tst	r0
		breq	ShowT_End
		mov	DispDat,r0
		cpi	DispDat,0xDF	;""
		brne	STUL_ae
		ldi	DispDat,CHR_sz
STUL_ae:	cpi	DispDat,0x7b	;" / {"
		brne	STUL_oe
		ldi	DispDat,CHR_ae
STUL_oe:	cpi	DispDat,0x7c	;" / |"
		brne	STUL_ue
		ldi	DispDat,CHR_oe
STUL_ue:	cpi	DispDat,0x7d	;" / }"
		brne	STUL_nU
		ldi	DispDat,CHR_ue
STUL_nU:	rcall	Disp_Send_Data
		ld	r0,Z+		;*** Z=Z+1 ***
		rjmp	ShowT_Loop
ShowT_End:	PopZ
		ret
		

		



Pause_n20ms:	;T0=8+(Pa_0-1)*4
		;T1=T0+7+(Pa_1-1)*T0+3
		;==160026Takte=20,00325ms
		;bergabe in WorkU1
P20m_L2:	push	TempU1		;2
		ldi	TempU1,178	;1
P20m_L1:	push	TempU1		;2
		ldi	TempU1,223	;1
P20m_L0:	dec	TempU1		;1
		tst	TempU1		;1
		brne	P20m_L0		;1/2
		pop	TempU1		;2
		dec	TempU1		;x1
		brne	P20m_L1		;x1/2
		pop	TempU1		;x2
		dec	WorkU1
		brne	P20m_L2
		ret
		
	
Set_Licht:	ldd	TempU1,Z+Taste
		cpi	TempU1,1	;Taste "0"
		brne	Set_Licht_M0
		sbi	PortA,LichtNetz_Bit	;Licht aus
		rjmp	Set_Licht_M1
Set_Licht_M0:	cpi	TempU1,2	;Taste "1"
		brne	Set_Licht_M1
		cbi	PortA,LichtNetz_Bit	;Licht ein
Set_Licht_M1:	ldi	DispDat,134
		rcall	Disp_Send_Code
		ldiw_m	X,Licht_AUS_Txt
		sbis	PortA,LichtNetz_Bit
		ldiw_m	X,Licht_EIN_Txt
		rjmp	ShowText
		;ret

GoSend:		;entsprechend dem Gert Senderoutine aufrufen
		ldd	TempU1,Z+Taste
		tst	TempU1
		breq	GoSend_ex	;-> keine gltige Taste
		in	TempU1,PortA
		andi	TempU1,0b11101000	;nur Netzbits
		ldi	TempU2,0b00001000
		eor	TempU1,TempU2
		cpi	TempU1,0b11101000	;alle aus ??
		brne	GoSend_do

		ldd	TempU1,Z+Taste
		ldi	TempU2,Taste_EXIT
		cpse	TempU1,TempU2
		rjmp	GoSend_do
		ldd	TempU1,Z+TasteL1
		cpse	TempU1,TempU2
		rjmp	GoSend_do
		;ldd	TempU1,Z+TasteL2
		;cpse	TempU1,TempU2
		;ret
	;2x EXIT gedrckt
		rcall	SetPower_OFF
		
GoSend_do:		ldd	TempU1,Z+Geraet
GoSend_01:	cpi	TempU1,1	;TV ??
		brne	GoSend_02
		rjmp	Send_TV
GoSend_02:	cpi	TempU1,2	;VCR ??
		brne	GoSend_03
		rjmp	Send_VCR
GoSend_03:	cpi	TempU1,3	;SAT ??
		brne	GoSend_04
		rjmp	Send_HiFi
GoSend_04:	cpi	TempU1,4	;Licht ??
		brne	GoSend_ex
		rjmp	Set_Licht
GoSend_ex:	ret





DisplayLight:	;Displaybeleuchtung entsprechend der aktuellen
		;Parameter einschalten
		clr	TempU1
		ldd	TempU2,Z+Geraet
		tst	TempU2
		breq	DisL_set	;==> kein Gert !!
		cpi	TempU2,3	;?? HiFi
		breq	DisL_end	;==> kein Vernderung
		
		sbis	PORTA,VCRNetz_Bit
		ldi	TempU1,40	;VCR ein -> DUNKEL
		sbis	PORTA,HiFiNetz_Bit
		ldi	TempU1,40	;HiFi ein -> DUNKEL
		sbis	PORTA,LichtNetz_Bit
		ldi	TempU1,40	;Licht ein -> DUNKEL
		sbis	PORTA,TVNetz_Bit
		ldi	TempU1,200	;TV ein -> HELL

DisL_set:	out	OCR1AL,TempU1
DisL_end:	ret



STimer0_BREAK:	;Timer stoppen
		in	TempU1,TIMSK
		andi	TempU1,127	;Timer1 OV aus
		out	TIMSK,TempU1
		ret

STimer0_START:	;Zeit in X
		cli
		mov	SEC_CtrL,X_L
		mov	SEC_CtrH,X_H
STimer0_GO:	in	TempU1,TIMSK
		ori	TempU1,128	;TIMER1 OV (b7) ein
		out	TIMSK,TempU1
		sei
		ret

STimer0_END:	;Aufruf wenn Zeit abgelaufen ...
	;Timer stoppen
		sbrc	TVProgMode,0
		rjmp	ST0_nPA
		mov	TempU1,TVProg
		andi	TempU1,0x0F
		cpi	TempU1,0x0F
		breq	ST0_nPA
		mov	TempU1,TVProg
		andi	TempU1,0xF0
		cpi	TempU1,0xF0
		breq	ST0_nPA
	;2 Programme gespeichert
		ldi	TV_Send_Code,10		;_/__
		rcall	Send_TV_Send
		ldi	WorkU1,38		;760ms
		rcall	Pause_n20ms
		mov	TV_Send_Code,TVProg
		swap	TV_Send_Code
		andi	TV_Send_Code,0x0F	;Zehner
		rcall	Send_TV_Send
		ldi	WorkU1,25		;500ms
		rcall	Pause_n20ms
		mov	TV_Send_Code,TVProg
		andi	TV_Send_Code,0x0F	;Einer
		rcall	Send_TV_Send
ST0_nPA:	clr	TVProg
		dec	TVProg			;0xFF
		ret



;**** H A U P T P R O G R A M M *****
;************************************
					
Start:		clr	ISNULL
	;PortA Init
		ldi	workU,PortA_DAT
		out	PortA,workU
		ldi	workU,PortA_DIR
		out	DDRA,workU
	;PortB Init
		ldi	workU,PortB_DAT
		out	PortB,workU
		ldi	workU,PortB_DIR
		out	DDRB,workU
	;PortC Init
		ldi	workU,PortC_DAT
		out	PortC,workU
		ldi	workU,PortC_DIR
		out	DDRC,workU
	;PortD Init
		ldi	workU,PortD_DAT
		out	PortD,workU
		ldi	workU,PortD_DIR_R
		out	DDRD,workU
	;Stakepointer setzen
START2:		ldi	WorkU,High(RAMEND)
		out	SPH,WorkU
		ldi	WorkU,Low(RAMEND)
		out	SPL,WorkU
	;Datenpuffer fr Indirekte Adressierung setzen
		ldi	DATA_L,low(DATA)
		ldi	DATA_H,high(DATA)

	;#############
	;Gert ein ..
		clr	PWR_PulseCnt
		sbi	PORTA,GerOn2_Bit
		ldi	TempU1,20
		mov	SysTime_Cnt,TempU1	
		
	;Timer0 einschalten
		ldi	WorkU,128 + 2
		out	TIMSK,WorkU	;Timer0 & 1 OV_INT EIN
	;Timer 1 PWM-Mode
		ldi	WorkU,0b10000001
		out	TCCR1A,WorkU
		ldi	WorkU,0b00000011
		out	TCCR1B,WorkU
		clr	WorkU
		out	OCR1AH,WorkU
		Dimmer_n	128	;Helligkeit 50%
		sei

		rcall	Init_Display	;Display Init
		ldi	WorkU1,5	;25*20ms=500ms
		rcall	Pause_n20ms

		sbi	PortA,HiFiNetz_Bit	;HiFi_EIN !!
;Beginn der  Haupschleife

		ldi	DispDat,1
		rcall	Disp_Send_Code
		clr	TempL1
		clr	HiFi_Togg
		std	Z+Geraet,TempL1
		std	Z+Taste,TempL1
		std	Z+TasteL1,TempL1
		std	Z+TasteL2,TempL1
		inc	TempL1
		sts	ShowCode_M,TempL1
		clr	TVProgMode
		clr	TVProg
		dec	TVProg
		rcall	ShowGer

Hauptschleife:
		rcall	WaitInput	;wenn T=1 dann gltige Taste
		rcall	STimer0_GO	;Timer starten
		brtc	Hauptschleife
		
		rcall	GoSend
		rcall	DisplayLight
		ldi	TempU1,71	;7 Sec
		mov	SysTime_Cnt,TempU1
		
		in	TempU1,PortA
		andi	TempU1,0b11101000	;nur Netzbits
		ldi	TempU2,0b00001000
		eor	TempU1,TempU2
		cpi	TempU1,0b11101000	;alle aus ??
		brne	Hauptschleife
	;alle sind Gerte aus
		cli
		clr	SysTime_Cnt
		inc	SysTime_Cnt
		ldi	SysTime_25s,216		;90 Minuten
		sei
	;Dimmer_n	0
		rcall	ShowSwitchOff
		rjmp	Hauptschleife


.include	"Flash_def_datas.inc"



BEO_STS:	.db	50,110,110,110
BEO_AAUX_GO:	.db	110,110,110,110,170,110,50,110,110,110,110,170,110,230

STORED_DATAS_DEF:	;gespeicherte Einstelldaten Notfall
	.db	S_DS_Betiebsart,S_PC1853_SA00
	.db	S_PC1853_SA08,S_PC1853_BASS
	.db	S_PC1853_TREB,S_AUXMODE_NDEC
	.db	S_AUXMODE_DEC,S_GerPowerON
	.db	S_AutoPowerOff,S_PowerON_Vol
	.db	S_CenterVol

PROGRAM_END:	.dw	0	;Programmende

.dseg		;RAM DATEN
.org	$60	;RamBeg
BeoReadBits:	.byte	14
KeyCode:	.byte	2
DevCode:	.byte	2
ShowCode_M:	.byte	1


DATA:;Betriebsdaten (aktuelle Einstellungen u. Werte) 
_Taste:		.byte	1	;+ 0
_Taste1:	.byte	1	;+ 1
_Taste2:	.byte	1	;+ 2
_PC1853_BASS:	.byte	1	;+ 3
_PC1853_TREB:	.byte	1	;+ 4
_AUXMODE_NDEC:	.byte	1	;+ 5
_AUXMODE_DEC:	.byte	1	;+ 6
_GerPowerON:	.byte	1	;+ 7
_AutoPowerOff:	.byte	1	;+ 8
_PowerON_Vol:	.byte	1	;+ 9
_CenterVol:	.byte	1	;+10
_x0011:		.byte	1	;+11
_LTaste:	.byte	1	;+12
_Geraet:	.byte	1	;+13
_DS_SetupMode:	.byte	1	;+14
_GVolume:	.byte	1	;+15
_TVistan:	.byte	1	;+16
_Ank_Netz_Aus:	.byte	1	;+17
_InputBitSave:	.byte	1	;+18
_DataLoadErr:	.byte	1	;+19
_METZ_BCnt:	.byte	1	;+20

